/*
Copyright (C) 2018 - 2019 Taisuke Kobayashi
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
// page etsuran

var pe_vt = [0, 0, "", 0] // 合計, 経過日数, カレント日付, 日計

function pe(_n = 100){
  var s = "<button onClick=pt()>戻る</button>" +
"<button onClick=pe_pk(0)>区1</button>" +
"<button onClick=pe_pk(1)>区2</button>" +
"<button onClick=pe_pk(2)>区3</button>" +
"<button onClick=pe(-1)>全部</button><br>"
  var d1 = data.get()
  var i
  d1.sort()
  pe_vt = [0, 0, "", 0] // 合計, 経過日数, カレント日付, 日計
  var sa = []
  for(i = 0; i < d1.length; i++){
    var s1 = pe_seikei(d1[i])
    if(s1 != "") sa.push(s1)
  }
  if(_n > 0 && _n < sa.length)
    sa.splice(0, sa.length - _n)
  sa.reverse()
  s +=
"<table border=1>" +
"<tr><td>金メ</td><td>時間</td><td>区2</td>" +
"<td>区1</td><td>日計</td><td>日</td><td>区3</td>" +
"<td>メモ</td><td>集区</td><td>key</td></tr>" +
sa.join("")
  s += "</table>"
  naiyou.innerHTML = s
}

// 0    1  2  3  4  5  6  7   8        9    10    11    12    13   14?          15?
// 2019,02,09,土,14,46,30,130,集計区分,金額,区分1,区分2,区分3,メモ,新規登録日時,key
function pe_seikei(_s){
  var s = ""
  var sa = _s.split(",")                 
  var s1 = sa[2] + sa[3]
  var s2 = ""
  var yosan_hi = Math.floor(va_for_settei[0] *10000/365)
  if(pe_vt[2] != s1){ // 合計, 経過日数, カレント日付, 日計
    var yjs = (yosan_hi * pe_vt[1] - pe_vt[0])
    s2 += "<tr><td colspan=10 bgcolor=#ff0>"
    s2 += pe_vt[2] + " "
    s2 += Math.floor( (yosan_hi - pe_vt[3]) /1000) + "日"
    s2 += Math.floor(yjs /1000) + "計 "
    s2 += pe_vt[3] + "円 "
    s2 += "" + yjs + "差 "
    s2 += pe_vt[0] + "円 " 
    s2 += pe_vt[1] + "日"
    s2 += "</td></tr>"
    pe_vt[1]++
    pe_vt[2] = s1
    pe_vt[3] = 0
  }
  var kingaku = 0
  if(sa[8] == pt_sk_sa[0]){ // 通常の時のみ。集計区分が。
    if(sa[9] != "") kingaku = parseInt(sa[9])
    pe_vt[0] += kingaku
    pe_vt[3] += kingaku
  }
  // 金メ 時間 区2 区1 日計 日 区3 メモ 集区 key
  s += "<tr>"
  s += pe_seikei_sub(-1, sa[9], 4, true)
  s += "<td>" + sa[4] + ":" + sa[5] + "</td>"
  s += pe_seikei_sub(1, sa[11], 3, false)
  s +=  pe_seikei_sub(0, sa[10], 3, false)
  if(kingaku != 0) s += pe_seikei_sub(-1, pe_vt[3], 5, true)
  else s += "<td></td>"
  s += "<td>" + sa[2] + sa[3] + "</td>"
  s +=  pe_seikei_sub(2, sa[12], 3, false)
  s +=  pe_seikei_sub(-1, sa[13], 3, false)
  s += "<td>" + sa[8] + "</td>"
  s += "<td class=a>" + sa[sa.length -1] + "</td>"
  s += "</tr>"
  s += s2
  return s
}

function pe_seikei_sub(i, s, n, is_a){
  s = "" + s
  var s1 = "<td>"
  if(is_a) s1 = "<td class=a>"
  if(i >= 0) s1 += "<button class=b onClick=pe_kubun_button(" + i + ",\"" + s + "\")>"
  if(s.length > n){
    if(is_a){
      s1 += s.substr(s.length - n)
    }else{
      var n1 = n
      if(s.match(/^\w+$/) ) n1 = n *2 -1
      s1 += s.substr(0, n1)
    }
  }else{
    s1 += s
  }
  if(i >= 0) s1 += "</button>"
  return s1 + "</td>"
}

function pe_kubun_button(i, v){
  va_for_kubun[i] = v
  pe_kubun(i)
}

function pe_pk(i){
  return_func_for_kubun = pe_kubun
  pk(i)
}

function pe_kubun(i1, _n = 100){
  var s = "<button onClick=pt()>最初</button>" +
"<button onClick=pe()>閲覧</button>" +
"<button onClick=pe_pk(" + i1 + ")>選択</button>" +
"<button onClick=pe_kubun(" +  i1 + "," + -1 + ")>全部</button><br>"
  var d1 = data.get()
  var i
  d1.sort()
  pe_vt = [0, 0, "", 0] // 合計, 経過日数, カレント日付, 日計
  var sa = []
  for(i = 0; i < d1.length; i++){
    var a1 = d1[i].split(",")
    if(a1[10+i1] == va_for_kubun[i1]) // 目的の区分1,2,3の項目だったら。
      sa.push(pe_kubun_seikei(a1) )
  }
  if(_n > 0 && _n < sa.length)
    sa.splice(0, sa.length - _n)
  sa.reverse()
  s +=
  // 日 計 金メ 区1 区2 区3 メモ 集区 月 時間 key
"<table border=1>" +
"<tr><td>日</td><td>計</td><td>金メ</td><td>区1</td><td>区2</td><td>区3</td><td>メモ</td>" +
"<td>集区</td><td>月</td><td>時間</td><td>key</td></tr>" +
sa.join("")
  s += "</table>"
  naiyou.innerHTML = s
}

// 0    1  2  3  4  5  6  7   8        9    10    11    12    13   14?          15?
// 2019,02,09,土,14,46,30,130,集計区分,金額,区分1,区分2,区分3,メモ,新規登録日時,key
function pe_kubun_seikei(sa){
  var kingaku = 0
  if(sa[8] == pt_sk_sa[0]){ // 通常の時のみ。集計区分が。
    if(sa[9] != "") kingaku = parseInt(sa[9])
    pe_vt[0] += kingaku
  }
  // 日 計 金メ 区1 区2 区3 メモ 集区 月 時間 key
  var s = ""
  s += "<tr>"
  s += "<td>" + sa[2] + sa[3] + "</td>"
  if(kingaku > 0)
    s += "<td class=a>" + pe_vt[0] + "</td><td class=a>" + sa[9] + "</td>"
  else
    s += "<td></td><td class=a>" + sa[9] + "</td>"
  s += "<td>" + sa[10] + "</td>"
  s += "<td>" + sa[11] + "</td>"
  s += "<td>" + sa[12] + "</td>"
  s += "<td>" + sa[13] + "</td>"
  s += "<td>" + sa[8] + "</td>"
  s += "<td>" + sa[1] + "</td>"
  s += "<td>" + sa[4] + ":" + sa[5] + "</td>"
  s += "<td>" + sa[sa.length -1] + "</td>"
  s += "</tr>"
  return s
}
